#include <fcntl.h>
#include <sched.h>
#include <semaphore.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <sys/wait.h>


void fonction_processus(int numero)
{
	int i, j;
	time_t debut, fin;
	sem_t * sem = sem_open("/solution-07-01", O_RDWR);
	if (sem == SEM_FAILED) {
		perror("sem_open");
		exit(EXIT_FAILURE);
	}
	
	// Attendre la synchronisation
	sem_wait(sem);
	sem_post(sem);
	
	time(& debut);
	for (i = 0; i < 100000; i ++)
		for (j = 0; j < 10000; j ++)
			;
	time(& fin);
	
	printf("[%d] %ld -> %ld\n", numero, debut, fin);
	exit(EXIT_SUCCESS);
}


#define NB_PROCESSUS 5

int main(void)
{
	int i;
	int pid;
	sem_t * sem;
	struct sched_param param;

	// Destruction de l'eventuel semaphore precedent
	sem_unlink("/solution-07-01"); 
	// Creation d'un semaphore initialement a zero
	sem = sem_open("/solution-07-01", O_CREAT | O_RDWR, 0600, 0);
	if (sem == SEM_FAILED) {
		perror("sem_open");
		exit (EXIT_FAILURE);
	}
	
	param.sched_priority = 40;
	for (i = 0; i < NB_PROCESSUS; i ++) {
		pid = fork();
		if (pid == 0)
			fonction_processus(i);
		if (sched_setscheduler(pid, SCHED_RR, & param) != 0) {
			perror("sched_setscheduler");
			kill(pid, SIGKILL);
			exit(EXIT_FAILURE);
		}
	}
	
	// Débloquage du sempahore
	sem_post(sem);
	
	for (i = 0; i < NB_PROCESSUS; i ++)
		waitpid(-1, NULL, 0);
	
	return EXIT_SUCCESS;
}

