#include <fcntl.h>
#include <sched.h>
#include <semaphore.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/wait.h>

void processus_P2(void);
void processus_P3(void);


void processus_P1(void)
{
	pid_t pid;
	sem_t * sem;
	struct sched_param param;

	fprintf(stderr, "P1 demarre\n");

	// Passer en priorite 10
	param.sched_priority = 10;
	if (sched_setscheduler(0, SCHED_FIFO, & param) != 0) {
		perror("sched_setscheduler");
		exit(EXIT_FAILURE);
	}

	// Creer un semaphore partage
	sem_unlink("/solution-07-02");
	sem = sem_open("/solution-07-02", O_RDWR | O_CREAT, 0600, 1);
	

	fprintf(stderr, "P1 demande le sempahore\n");
	sem_wait(sem);
	fprintf(stderr, "P1 tient le semaphore\n");

	fprintf(stderr, "P1 cree P3\n");
	pid = fork();
	if (pid == 0) {
		processus_P3();
		// P3 ne revient pas
	}
	// Passer P3 en temps reel
	param.sched_priority = 30;
	sched_setscheduler(pid, SCHED_FIFO, & param);
	
	fprintf(stderr, "P1 cree P2\n");
	pid = fork();
	if (pid == 0) {
		processus_P2();
		// P2 ne revient pas
	}
	// Passer P2 en temps reel
	param.sched_priority = 20;
	sched_setscheduler(pid, SCHED_FIFO, & param);

	fprintf(stderr, "P1 lache le semaphore\n");
	sem_post(sem);
	fprintf(stderr, "P1 se termine\n");
	// Attente des deux processus fils
	waitpid(-1, NULL, 0);
	waitpid(-1, NULL, 0);
	exit(EXIT_SUCCESS);
}


void processus_P2(void)
{	
	int i, j;
	fprintf(stderr, "    P2 demarre\n");
	for (i = 0; i < 100000; i ++)
		for (j = 0; j < 10000; j ++)
			;
	fprintf(stderr, "    P2 se termine\n");
	exit(EXIT_SUCCESS);
}


void processus_P3(void)
{
	int i, j;
	sem_t * sem;
	fprintf(stderr, "        P3 demarre\n");
	sem = sem_open("/solution-07-02", O_RDWR);
	fprintf(stderr, "        P3 demande le semaphore\n");
	sem_wait(sem);
	fprintf(stderr, "        P3 tient le semaphore\n");
	for (i = 0; i < 100000; i ++)
		for (j = 0; j < 10000; j ++)
			;
	fprintf(stderr, "        P3 lache le semaphore\n");
	sem_post(sem);
	fprintf(stderr, "        P3 se termine\n");
	exit(EXIT_SUCCESS);
}



int main(int argc, char * argv [])
{
	if (fork() == 0)
		processus_P1();
	else
		waitpid(-1, NULL, 0);
	return EXIT_SUCCESS;
}


