#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/time.h>
#include <sys/wait.h>

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_t thr1, thr2, thr3;
pthread_attr_t attr1, attr2, attr3;

void * fonction_1(void *unused);
void * fonction_2(void * unused);
void * fonction_3(void * unused);


void prendre_mutex(pthread_mutex_t * mtx, int * saved_sched, int * saved_prio)
{
	struct sched_param param;
	pthread_getschedparam(pthread_self(), saved_sched, & param);
	* saved_prio = param.sched_priority;
	
	param.sched_priority = sched_get_priority_max(SCHED_FIFO);
	pthread_setschedparam(pthread_self(), SCHED_FIFO, & param);
	
	pthread_mutex_lock(mtx);
}


void lacher_mutex(pthread_mutex_t * mtx, int saved_sched, int saved_prio)
{
	struct sched_param param;
	pthread_mutex_unlock(mtx);
	param.sched_priority = saved_prio;
	pthread_setschedparam(pthread_self(), saved_sched, & param);
}



void * fonction_1(void *unused)
{
	int sched, prio;
	
	fprintf(stderr, "T1 demarre\n");
	
	fprintf(stderr, "T1 demande le mutex\n");
	prendre_mutex(& mutex, & sched, & prio);
	fprintf(stderr, "T1 tient le mutex\n");

	fprintf(stderr, "T1 cree T3\n");
	pthread_create(& thr3, &attr3, fonction_3, NULL);
	
	fprintf(stderr, "T1 cree T2\n");
	pthread_create(& thr2, &attr2, fonction_2, NULL);
	
	fprintf(stderr, "T1 lache le mutex\n");
	lacher_mutex(& mutex, sched, prio);
	fprintf(stderr, "T1 se termine\n");
	return NULL;
}


void * fonction_2(void * unused)
{	
	int i, j;
	fprintf(stderr, "    T2 demarre\n");
	for (i = 0; i < 100000; i ++)
		for (j = 0; j < 10000; j ++)
			;
	fprintf(stderr, "    T2 se termine\n");
	return NULL;
}


void * fonction_3(void * unused)
{
	int i, j;
	int sched, prio;
	
	fprintf(stderr, "        T3 demarre\n");
	fprintf(stderr, "        T3 demande le mutex\n");
	prendre_mutex(& mutex, & sched, & prio);
	fprintf(stderr, "        T3 tient le mutex\n");
	for (i = 0; i < 100000; i ++)
		for (j = 0; j < 10000; j ++)
			;
	fprintf(stderr, "        T3 lache le mutex\n");
	lacher_mutex(& mutex, sched, prio);
	fprintf(stderr, "        T3 se termine\n");
	return NULL;
}



int main(int argc, char * argv [])
{
	struct sched_param param;
	pthread_attr_init(& attr1);
	pthread_attr_init(& attr2);
	pthread_attr_init(& attr3);
	pthread_attr_setschedpolicy(& attr1, SCHED_FIFO);
	pthread_attr_setschedpolicy(& attr2, SCHED_FIFO);
	pthread_attr_setschedpolicy(& attr3, SCHED_FIFO);
	param.sched_priority = 10;
	pthread_attr_setschedparam(& attr1, & param);
	param.sched_priority = 20;
	pthread_attr_setschedparam(& attr2, & param);
	param.sched_priority = 30;
	pthread_attr_setschedparam(& attr3, & param);
	pthread_attr_setinheritsched(& attr1, PTHREAD_EXPLICIT_SCHED);
	pthread_attr_setinheritsched(& attr2, PTHREAD_EXPLICIT_SCHED);
	pthread_attr_setinheritsched(& attr3, PTHREAD_EXPLICIT_SCHED);
	
	pthread_create(& thr1, & attr1, fonction_1, NULL);
	pthread_join(thr1, NULL);
	return 0;
}
