#include <fcntl.h>
#include <sched.h>
#include <semaphore.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>


int main(void)
{
	sigset_t sigset;
	
	sem_t * sem;
	
	sem = sem_open("/solution-07-05", O_RDWR | O_CREAT, 0600, 1);
	if (sem == SEM_FAILED) {
		perror("sem_open");
		exit(EXIT_FAILURE);
	}
	
	sigfillset(& sigset); // Tous les signuax blocables
	
	while(1) {
		// Bloquer tous les signaux
		sigprocmask(SIG_BLOCK, & sigset, NULL);
		
		fprintf(stderr, "[%d] demande le semaphore\n", getpid());
		sem_wait(sem);
		fprintf(stderr, "   [%d] tient le semaphore\n", getpid());
		
		sleep(1);
		
		fprintf(stderr, "   [%d] lache le semaphore\n", getpid());
		sem_post(sem);
		
		// Debloquer tous les signaux
		sigprocmask(SIG_UNBLOCK, & sigset, NULL);
		sched_yield();
	}
	return EXIT_SUCCESS;
}

