#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>

#include <rtdk.h>
#include <native/task.h>
#include <native/timer.h>


void fonction_boucle (void * unused)
{
	sleep(1);
	rt_timer_spin(10000000000LLU);
}


int main(void)
{
	int i;
	int nb_cpus;
	int err;
	RT_TASK * tasks;
	char taskname[32];
	
	nb_cpus = sysconf(_SC_NPROCESSORS_ONLN);
	mlockall(MCL_CURRENT|MCL_FUTURE);
	rt_print_auto_init(1);
	
	tasks = calloc(nb_cpus, sizeof(RT_TASK));
	if (tasks == NULL) {
		perror("calloc");
		return EXIT_FAILURE;
	}
	
	for (i = 0; i < nb_cpus; i ++) {
		sprintf(taskname, "solution-10-01-%d\n", i);
		if ((err = rt_task_spawn(& (tasks[i]), taskname, 0, 99, T_JOINABLE | T_CPU(i),
							fonction_boucle, NULL)) != 0) {
			fprintf(stderr, "rt_task_spawn: %s\n", strerror(-err));
			exit(EXIT_FAILURE);
		}
	}
	for (i = 0; i < nb_cpus; i ++) {
		rt_task_join(& (tasks[i]));
	}
	return EXIT_SUCCESS;
}

