#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>

#include <rtdk.h>
#include <native/task.h>
#include <native/timer.h>


void fonction_tache (void * unused)
{
	RTIME avant;
	RTIME apres;
	RTIME duree;
	while (1) {
		sleep(1);
		avant = rt_timer_read();
		rt_task_sleep(1000000000LLU); // 1 seconde
		apres = rt_timer_read();
		duree = apres - avant;
		rt_printf("duree : %lld\n", duree);
	}
}


int main(void)
{
	int err;
	RT_TASK task;
	
	mlockall(MCL_CURRENT|MCL_FUTURE);
	rt_print_auto_init(1);
	
	if ((err = rt_task_spawn(& task, "solution-10-02", 0, 99, T_JOINABLE,
					fonction_tache, NULL)) != 0) {
		fprintf(stderr, "rt_task_spawn: %s\n", strerror(-err));
		exit(EXIT_FAILURE);
	}
	
	rt_task_join(& task);
	return EXIT_SUCCESS;
}

